{$M $800,0,0 }   { 2K stack, no heap }
{ This program causes a click each time
 a key is pressed.}
uses Dos;
var
  tmpPtr           : Pointer;
  MouseIntVec      : Pointer;
  OldMouseCallBack : Pointer;

  Buttons,
  mouseX,
  mouseY,
  mouseMoveX,
  mouseMoveY,
  mouseMaxX,
  mouseMaxY,
  moveRateX,
  moveRateY    : Integer;
  Prog,Arg     : String;

procedure MouseIntVecP;
begin
  asm
    dw 0;
    dw 0;
    dw 0;
  end;
end;
procedure OldMouseCallBackP;
begin
  asm
    dw 0;
    dw 0;
    dw 0;
  end;
end;
{$F+}
procedure MouseCallBack(Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP: Integer); interrupt;
begin

  if (AX and 1)>0 then begin { mouse moved }
    Asm
      Mov  AX,0Bh
      PushF
      Call MouseIntVec;
      Mov  mouseMoveX,CX
      Mov  mouseMoveY,DX
    end;
    mouseX:=MouseX+mouseMoveX*moveRateX;
    mouseY:=MouseY+mouseMoveY*moveRateY;
    { check mouse range }
    if mouseX<0 then mouseX:=0;
    if mouseY<0 then mouseY:=0;
    if mouseX>mouseMaxX then mouseX:=mouseMaxX;
    if mouseY>mouseMaxY then mouseY:=mouseMaxY;
    { end check }
  end;
  if OldMouseCallBack=nil then begin
   Asm
     Pop BP
     Pop ES
     Pop DS
     Pop DI
     Pop SI
     Pop DX
     Pop CX
     Pop BX
     Pop AX
     RetF;
    end;
   end;

  CX:=mouseX;
  DX:=mouseY;
  asm
     Pop BP
     Pop ES
     Pop DS
     Pop DI
     Pop SI
     Pop DX
     Pop CX
     Pop BX
     Pop AX
     jmp OldMouseCallBackP
  end;
end;
procedure MyMouseInt(Flags, CS, IP, _AX, _BX, _CX, _DX, SI, DI, DS, _ES, BP: Integer); interrupt;
label
  IRet;
begin

  if (_AX=$0C) and (_CX<>0) then begin { set user callback proc }
    OldMouseCallBack:=Ptr(_ES,_DX);
    tmpPtr:=@OldMouseCallBackP;
    { fill jump to old MouseCallBack in Code segment }
    Asm
      les di,[tmpPtr]
      les si,[OldMouseCallBack]
      mov al,$EA;
      mov cs:[di],AL
      mov cs:[di+1],si
      mov cs:[di+3],es
    End;
    _ES:=Seg(MouseCallBack);
    _DX:=Ofs(MouseCallBack);
  end;

  if (_AX=$04) then begin   { set mouse x,y }
    { check mouse range }
    if _CX<0 then _CX:=0;
    if _DX<0 then _DX:=0;
    if _CX>mouseMaxX then _CX:=mouseMaxX;
    if _DX>mouseMaxY then _DX:=mouseMaxY;
    { end check }
    Asm
      Mov   AX,04h
      PushF
      Mov   CX,_CX
      Mov   DX,_DX
      Call  MouseIntVec
    end;
    MouseX:=_CX;
    MouseY:=_DX;
    goto IRet;
  end;

  if (_AX=$03) then begin { get mouse x,y,buttons }
    Asm
      Mov   AX,03h
      PushF
      Call  MouseIntVec
      mov   Buttons,BX
      {
      mov   MouseX,CX
      mov   MouseY,DX
      }
    end;
    _CX:=MouseX;
    _DX:=MouseY;
    _BX:=Buttons;

    goto IRet;
  end;

  Asm
    Pop BP
    Pop ES
    Pop DS
    Pop DI
    Pop SI
    Pop DX
    Pop CX
    Pop BX
    Pop AX
    Jmp MouseIntVecP
  end;
IRet:
end;
{$F-}
function Str2Int (S: String): Integer;
var
  I,c : Integer;
begin
  Val(S,i,c);
  if c<>0 then i:=0;
  Str2Int:=i;
end;

begin
  WriteLn('Mouse2k2 v2.0'^M^J'Win2k/NTVDM/VESA/Mouse utility by GMax'^M^J+
          'based on original Mouse2kV by Peter Maceluch'^M^J);
  WriteLn('Designed to address the issues with mouse cursor being unable'^M^J+
    'to reach whole screen in some DOS programs in Win2k'^M^J);
  WriteLn('Special thanks to Vlad ROMASCANU for MOUSESET sources this program'^M^J'was based on.'^M^J);
  if ParamCount<5 then begin
    WriteLn('Incorrect number of arguments'^M^J'  USAGE: MOUSE2K2 xmax ymax xspeed yspeed program.exe'^M^J'where:');
    WriteLn(' xmax, ymax     - maximum coordinates for mouse cursor,'^M^J+
            '      (when negative, the values are not multiplied internally by 8)'^M^J,
            ' xspeed, yspeed - multiplier for mouse speed (usually 8)'^M^J,
            ' program.exe    - program to launch with altered mouse support'^M^J^J,
            ' eg. mouse2k2 640 480 8 8 xcomapoc.exe'^M^J^J);
    Halt;
  end;

  mouseMoveX :=0;
  mouseMoveY :=0;
  mouseMaxX :=Str2Int(ParamStr(1));
  mouseMaxY :=Str2Int(ParamStr(2));
  moveRateX :=Str2Int(ParamStr(3));
  moveRateY :=Str2Int(ParamStr(4));
  Prog:=ParamStr(5); Arg:='';
  for mouseX:=6 to ParamCount do
    Arg:=Arg+' '+ParamStr(mouseX);
  Delete(Arg,1,1);
  if (mouseMaxX=0) or (mouseMaxY=0) or
     (moveRateX=0) or (moveRateY=0) then begin
    WriteLn('Incorrect parameters');
    Halt;
  end;
  if mouseMaxX<0 then mouseMaxX:=-mouseMaxX
  else mouseMaxX:=(mouseMaxX-1)*8;
  if mouseMaxY<0 then mouseMaxY:=-mouseMaxY
  else mouseMaxY:=(mouseMaxY-1)*8;

  GetIntVec($33,MouseIntVec);
  tmpPtr:=@MouseIntVecP;
  { fill jump to old MouseIntVec in Code segment }
  Asm
    les di,[tmpPtr]
    les si,[MouseIntVec]
    mov al,$EA;
    mov cs:[di],AL
    mov cs:[di+1],si
    mov cs:[di+3],es
  End;
  MouseX:=0;
  MouseY:=0;

  SetIntVec($33,Addr(MyMouseInt));
  { hack to set our callback ;-) }
  Asm
    mov ax,04h
    xor cx,cx
    xor dx,dx
    int 33h
    xor ax,ax
    mov es,ax
    mov dx,ax
    mov cx,07Fh
    mov ax,0Ch
    int 33h
  end;
  SwapVectors;
  Exec(Prog,Arg);
  SwapVectors;
  SetIntVec($33,MouseIntVec);
end.
